#pragma rtGlobals=1		// Use modern global access method.

// AverageByCat(PoP,CatWave,Category) Averages all traces in the Populationwave PoP
// that fall in category Cat as encoded in the category-wave Category
//
// DisplayAndAverage(PoP,CatWave, Category) Displays the waves 
// that fall in category Category as encoded in the category-wave CatWave.
//
//DisplayAndAverageGetNames() calls a popup to run the above command.


Function AverageByCat(PoP,CatWave,Category)
Wave Pop,Catwave
Variable Category

variable ii, number=0

duplicate/o pop, AverageWave
redimension /n=(-1) AverageWave
AverageWave=0


for(ii=0;ii<numpnts(CatWave);ii+=1)	//sum up
	if(CatWave[ii]==Category)
		AverageWave[]+=PoP[p][ii]
		number+=1
	endif
endfor

AverageWave/=number					//make average

String NewName=NameofWave(PoP)+"_avg"+Num2Str(Category)

duplicate/o AverageWave, $NewName
killwaves/z NewName

End

///////////////////////////////////////////////////

Function DisplayAndAverageGetNames()

string PoP, CatWave
variable Category, ii


Prompt PoP, "The Populationwave", popup, WaveList("*",";","DIMS:2")
Prompt Catwave, "The Category Wave",popup,WaveList("*",";","DIMS:1")
Prompt Category, "Which category to display?"

DoPrompt "Your Variables, please",PoP,CatWave,Category

If(v_flag)//user cancelled
	return-1
endif

DisplayAndAverage($PoP,$CatWave, Category)

End

//////////////////////////////////////////////////

Function  DisplayAndAverage(PoP,CatWave, Category)
wave pop, catwave
variable category

variable ii

 AverageByCat(PoP,CatWave,Category)
String NewName=NameofWave(PoP)+"_avg"+Num2Str(Category)
 

 display;delayupdate
 
for(ii=0;ii<numpnts(CatWave);ii+=1)
	if(CatWave[ii]==Category)
		appendtograph Pop[][ii];delayupdate
	endif
	
endfor

appendtograph $NewName
ModifyGraph rgb($NewName)=(0,0,0)

doupdate

End